import java.awt.*;

/** Assignment A5 */
public class A5 extends Turtle {
    
    /** Constructor: a black turtle starting at the middle of the
      panel with angle 0 (looking east).
      East (right) is angle 0; north (up), 90; west (left), 180;
      South (down). 270. The pen is down.*/
    public A5() {
        super();
    }
    
    /** Draw a black line 30 pixels to the right (east) and then
      a blue line 35 pixels down (south).
      Precondition: the turtle is facing east.*/
    public void drawTwoLines() {
        Color save= getColor();
        
        moveAhead(30); // draw a line 30 pixels to the right (east) 
        addAngle(270); // add 270 degrees to the angle
        setColor(Color.blue);
        moveAhead(35);
        
        setColor(save);
    }
    
    /** Place the turtle in the center of the panel, facing east, and
      clear the window (make it white). */
    public void placeInCenter() {
        jumpTo(getWidth()/2, getHeight()/2, 0);
        clear();
    }
    
    /** = a representation of this Turtle, giving its position, the
          angle, it is facing, whether the pen is down, and its color. */
    public String toString() {
         /** ATTENTION. The x- and y-coordinates should be rounded
            using function Math.round(...) and then cast to type
            int before printing. Also note that Color has its own toString
            function.*/
        
       return "";
    }
    
    /** Draw an equilateral triangle of side length e and color c at the turtle's
      current position. UPON COMPLETION, THE following properties SHOULD BE THE
      SAME AS WHEN THE METHOD STARTED: turtle position, turtle direction,
      pen color, and whether the pen is up or down.
      Precondition: the pen is down. */
    public void drawTriangle(int e, Color c) {
        // Hint: each angle in an equilateral triangle is 60 degrees.
        // Note: Do NOT save the turtle position and direction in the beginning
        // and then restore them at the end. Instead, the turtle moves should be
        // such that the turtle ends up where it started and facing in the same
        // direction.
        Color save= getColor();
       
        // Put your code here and remove this comment. */
        
        setColor(save);
        
        /** When you have completed and tested this method, do the following
          instructions in the interactions pane to learn about round-off
          error caused by using type double instead of the mathematical
          type real:
          
          p= new A5();
          p.getX()
          p.drawTriangle(100,java.awt.Color.blue);
          p.getX()
          
          You will see that the x-coordinate is not the same before and after
          drawing the triangle. This is due to "round-off" errors that
          arise because type double uses only approximations to real numbers.
          
          This is OK here, because the pixels in the panel on which
          the drawing takes place are given by integers: the top left one is
          (0, 0) the one to its right is (1, 0), and so on. The turtle's
          drawing methods round double values to ints before actually drawing.
          
          Add a comment at the top of this file (A5.java) containing a
          cut-and-paste of the results in the Interaction pane of
          typing in the four lines specified in this comment.
          */
    }
    
    /** Draw six green equilateral triangles with side lengths d to
        form a hexagon, starting at the turtle's current position and
        angle.  Precondition: the pen is down. */
    public void drawGreenHex(int d) {
        
        
    }
    
    /** Do as in drawSpiral but clear screen and start
      at the center of the panel and angle 0. */
    public void drawSpiralMid(int ms, int n, int ang, int d) {
        
    }

    /**  Draw a spiral of n lines, beginning at the current turtle
      position and angle, using an angle of ang between adjacent
      lines and pausing ms milliseconds after each line.
      Line 1 is d pixels long; line 2, 2*d pixels, ..., so each line i
      is d*i pixels long. The lines should alternate between blue, red,
      and green, in that order, with the first one being blue. 
      End with the pen properties being the same as before the call.*/
    public void drawSpiral(int ms, int n, int ang, int d) {
        
    }
        
    /** Do as in radiate but clear screen and start at center of panel and angle 0. */
    public void radiateMid(int m, int n, int d) {
        
    }
    
    /** Draw n straight radiating lines of length d at equal angles.
      Pause m milliseconds after each line. A line drawn at angle
      ang, 0 <= ang < 360, should be drawn with the HSV color
      (ang, 1, 1). Precondition: n >= 2. */
    public void radiate( int m, int n, int d){
         
    }
    
    /** = color in RGB color space
      formulae from http://en.wikipedia.org/wiki/HSV_color_space */
    public static Color HSV2RGB(HSV HSV) {
        double H= HSV.h;
        double S= HSV.s;
        double V= HSV.v;
        
        int Hi= (int)Math.floor(H / 60.0) % 6;
        
        double f= H / 60 - Hi;
        double p= V * (1.0 - S);
        double q= V * (1.0 - f * S);
        double t= V * (1.0 - (1.0 - f) * S);
        double R, G, B;
        
        if (Hi == 0) {
            R= V;  G= t;  B= p;
        }
        else if (Hi == 1) {
            R= q;  G= V;  B= p;
        }
        else if (Hi == 2) {
            R= p;  G= V;  B= t;
        }
        else if (Hi == 3) {
            R= p;  G= q;  B= V;
        }
        else if (Hi == 4) {
            R= t;  G= p;  B= V;
        }
        else { // {Hi == 5}
            R= V;  G= p;  B= q;
        }
        
        return new Color((int)Math.round(R * 255.0),
                         (int)Math.round(G * 255.0),
                         (int)Math.round(B * 255.0));
    }
    
    /** Draw an n-sided polygon, ending up with the turtle
      being where it started out and facing the same
      direction, and with the pen properties the same, too.
      Each side is d pixels long. */
    public void drawPolygon(int n, int d) {
        // angle is the angle between 2 adjacent sides
        double angle= ((n-2) * 180.0) / n; 
        for (int j= 0; j < n; j= j+1) {
            moveAhead(d);
            addAngle(180 - angle);
        }
    }
    
    /** Draw 90 n-sided polygons of side length d, alternating
      between blue and red. Each one starts at the same place,
      but each one is at an angle 4 degrees more than the
      preceding one. Pause m milliseconds after each one. All
      properties of the turtle are the same at the end as they
      were in the beginning. */
    public void multiPolygons(int m, int n, int d) {
        
    }
   
    /** Make the graphics panel as big as possible, clear the panel, and
      draw a Sierpinksi triangle of depth d with side length s
      with the bottom left corner (x,y).
      Precondition: d >= 0 and s > 0. */
    public void sierpinski(double x, double y, int d, double s) {
        
    }
    
    /** Draw a Sierpinksi triangle of depth d with side length s and with
      the bottom left corner (x, y). 
      Precondition: d >= 0 and s > 0.*/
    private void sierpinski1(double x, double y, int d, double s){ 
        
        
    }
    
    /** Make the graphics panel as big as possible, clear the panel, and draw a Sierpinksi carpet of
      depth d with side length s. The turtle is positioned at the top left point of the carpet. 
      Precondition: d >= 0 and s > 0. */
    public void sierpinskicarpet(double x, double y, int d, double s) {
        
    }
    
    /** Draw a Sierpinksi carpet of depth d with side length s and with top left
      corner (x, y). 
      Precondition: d >= 0 and s > 0.*/
    private void sierpinskicarpet1(double x, double y, int d, double s){
        
        
    }
    
    /** Fill a square of size (s, s), with top-left corner at the turtle's position.
        Upon completion, the turtle should be at its original position. */
    public void fillSquare(double s) {
        
    }
    
    /** Draw an H at center (x, y) of size s. */
    public void drawH(double x, double y, double s) {
        
    }
    
    /** Make the graphics panel as big as possible, clear the panel, and draw an H-tree
      of depth d with center (x, y) and size s.  
      Precondition: d >= 0 and s >= 0 and w >= 0. */
    public void recursiveH(double x, double y, int d, double s) {
        
    }
    
    /** draw an H-tree of depth d with center (x, y) and size s.  
        Precondition: d >= 0 and s >= 0. */
    public void recursiveH1(double x, double y, int d, double s) {
        
    }
}